#include <iostream>

void plus_un_v1(int m)
// Passage par valeur.
// Cette fonction ne modifie *pas* ses arguments.
{
  m++;
}


void plus_un_v2(int *m)
// Passage par adresse (avec pointeurs)
// Cette fonction modifie la valeur situe à l'adresse qui lui est donnée en argument.
{
  (*m)++;
}


void plus_un_v3(int &m)
// Passage par adresse (avec réference)
// Même chose qu'avec les pointeurs, mais la syntaxe est plus naturelle.
{
  m++;
}


int main(void)
{
  int n=0;

  // Passage par valeur :
  std::cout << n << "\n";
  plus_un_v1(n);
  std::cout << n << "\n";


  // Passage par adresse :
  plus_un_v2(&n);
  // Avec des pointeurs : on fournit à la fonction l'*adresse* de la variable n.
  std::cout << n << "\n";
  
  plus_un_v3(n);
  // Avec des références : on ecrit simplement "n"
  std::cout << n << "\n";
  
}
